//******************************************************************************
//
//	File:		tsb.cpp
//
//	Copyright 1993-95, Be Incorporated
//
//
//******************************************************************************


#include <Debug.h>

#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <OS.h>

#include "tsb.h"
#include "x.h"		// enum cvMouseButton; cvMouseHandler; cvColor

#include <InterfaceDefs.h>

typedef ulong Index;

/*------------------------------------------------------------*/

BRect initRect( 0,0, 100,100 );

/*------------------------------------------------------------*/

TShowBit::TShowBit( BRect rect, long flags )
	:
	BView( rect, "", flags, B_WILL_DRAW ),		// | B_PULSE_NEEDED
	userRect( rect )
{
	rect.OffsetTo( 0, 0 );

	the_bitmap = new BBitmap(rect, B_COLOR_8_BIT, TRUE);

	artist = new BView( rect, "artist", flags, B_WILL_DRAW );

	the_bitmap->AddChild( artist );
}

/*------------------------------------------------------------*/

TShowBit::~TShowBit()
{
	delete the_bitmap;	// BBitmap deletes its child view.
}

/*------------------------------------------------------------*/

void	TShowBit::Draw(BRect update_rect)
{
	DrawBitmap(the_bitmap, BPoint(0, 0));
}

void	TShowBit::DrawView()
{
	Draw( BRect(0,0,0,0) );
}

void TShowBit::Clear()
{
	artist->FillRect( the_bitmap->Bounds(), B_SOLID_LOW );
}

void TShowBit::Lock()
{
	the_bitmap->Lock();
}

void TShowBit::Unlock()
{
	the_bitmap->Unlock();
}

/*------------------------------------------------------------*/

void	TShowBit::MouseDown(BPoint where)
{
	BPoint where2;
	ulong  buttons;
	GetMouse( &where2, &buttons );

	cvMouseButton mouseButton;
	
	if (buttons & B_PRIMARY_MOUSE_BUTTON)
		mouseButton = cvMouseButton1;
	else
	if (buttons & B_SECONDARY_MOUSE_BUTTON)
		mouseButton = cvMouseButton2;
	else
	if (buttons & B_TERTIARY_MOUSE_BUTTON)
		mouseButton = cvMouseButton3;

	cvMouseHandler( mouseButton, where.x, where.y, Bounds().Width(), Bounds().Height() );
}

/*------------------------------------------------------------*/

void TShowBit::Dispatch( Index viewIndex )
{
	the_bitmap->Lock();
	artist->FillRect( the_bitmap->Bounds(), B_SOLID_LOW );

	// This is the call to the function that decides which
	// type of graph or map to draw and calls the appropriate
	// drawing function.

	// cvDispatch();

	// But for this demo code, we draw a rectangle,
	// then decide whether to fill it with an "X" or an "O".

	BRect bounds( the_bitmap->Bounds() );
	artist->StrokeRect( bounds, B_SOLID_HIGH );

	if (viewIndex == 0) {
		artist->StrokeLine( bounds.LeftTop(), bounds.RightBottom(), B_SOLID_HIGH );
		artist->StrokeLine( bounds.LeftBottom(), bounds.RightTop(), B_SOLID_HIGH );
	} else {
		artist->StrokeArc( bounds, 0, 360, B_SOLID_HIGH );
	}

	artist->Sync();			// flush changes to the bitmap and wait for completion.
	the_bitmap->Unlock();
	Draw( BRect() );		// draw bitmap to window.
}

