
#include <Debug.h>

// #include <BeHeaders.pch++>	// increases compile time from 6 to 17 seconds for main.o!

#include <stdlib.h>

#include <OS.h>
#include <Application.h>
#include <Directory.h>
#include <File.h>
#include <Roster.h>
#include <Volume.h>
#include <Bitmap.h>
#include <MenuItem.h>
#include <Menu.h>
#include <MenuField.h>
#include <MenuBar.h>
#include <ScrollView.h>
#include <StringView.h>
#include <Alert.h>
#include <Beep.h>

#include <File.h>
#include <Directory.h>
#include <stdio.h>

#include "tsb.h"
#include "win.h"
// #include "proto.h"

#include <math.h>

/*------------------------------------------------------------*/
/// From cview.cc
void cvCallButton( Index viewIndex );
/*------------------------------------------------------------*/

float menubarHeight =  20;

/*------------------------------------------------------------*/

TMainWindow::TMainWindow(BRect bound, char *name, window_type type, long flags)
	: BWindow(bound, name, type, flags), viewIndex( 0 ), stateWidget(0), countWidget(0)
{
	// BMenuBar	*menubar;
	// BMenu	*a_menu;
	BPopUpMenu	*a_menu;
	BMenuItem	*item;

	Lock();

	/*
		// widgetWidth value is arbitrary--can get stringWidth??
		float widgetWidth = 50;
		BRect stateRect( 0, 0, widgetWidth, 15);
		BRect countRect( widgetWidth, 0, 2*widgetWidth, 15);
		stateWidget = new BStringView( stateRect, "stateWidget", "state" );
		countWidget = new BStringView( countRect, "countWidget", "count" );
		AddChild( stateWidget );
		AddChild( countWidget );
	*/

	// a_rect.Set( 0, 0, 1000, 15);
	// menubar = new BMenuBar(a_rect, "MB");
	// AddChild(menubar);
	// float menubarHeight = menubar->Bounds().Height();

	bitmapRect.Set(
		0, menubarHeight + 1,
		Bounds().Width(), Bounds().Height()
	);

	the_view = new TShowBit( bitmapRect, B_FOLLOW_ALL | B_WILL_DRAW );

	AddChild( the_view );

	Show();
	Unlock();
}

//------------------------------------------------------------

void TMainWindow::FrameResized(float width, float height)
{
	// printf( "new size: %dx%d\n", (int)width, (int)(height - (menubarHeight+1)) );
	// printf( "Bounds().Width() = %.1f, Bounds().Height() = %.1f\n", Bounds().Width(), Bounds().Height() );

	bitmapRect.Set(
		0, menubarHeight + 1,
		// width, height - (menubarHeight+1)	// Don't use the function args!
		Bounds().Width(), Bounds().Height()
	);

	if (!RemoveChild( the_view )) {
		printf( "TMainWindow::FrameResized: error removing the bitmap's child view\n" );
		exit(1);
	};

	delete the_view;
	the_view = new TShowBit( bitmapRect, B_FOLLOW_ALL | B_WILL_DRAW );

	AddChild( the_view );

	Dispatch( viewIndex );
}

void TMainWindow::Dispatch( Index viewIndex )
{
	Lock();
	the_view->Dispatch( viewIndex );
	Unlock();
}

void TMainWindow::SetStateString( const char* string )
{
	stateWidget->SetText( string );
}

void TMainWindow::SetCountString( const char* string )
{
	countWidget->SetText( string );
}

void TMainWindow::Draw()
{
	Lock();
	// Should keep userRect here rather than in TShowBit??
	the_view->DrawView();
	Unlock();
}

void TMainWindow::Clear()
{
	Lock();
	the_view->Clear();
	Unlock();
}

void TMainWindow::LockView()
{
	the_view->Lock();
}

void TMainWindow::UnlockView()
{
	the_view->Unlock();
}

/*------------------------------------------------------------*/

bool	TMainWindow::QuitRequested()
{
	// PostMessage(B_QUIT_REQUESTED);
	
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(TRUE);
}

/*------------------------------------------------------------*/

void	TMainWindow::MessageReceived(BMessage* event)
{
	viewIndex = event->what;

	// If msg is from a window menu, then the window will receive it.
	// So we already know which window.
	// So each window should maintain its own viewList.

	the_view->Dispatch( viewIndex );
}

