
// Believe it or not, /usr/include/X11/X.h uses "ifndef X_H"
#ifndef cvX_H
#define cvX_H

enum { false, true };

#include <stdarg.h>

enum cvMouseButton { cvMouseButton1, cvMouseButton2, cvMouseButton3 };

void cvMouseHandler( cvMouseButton mouseButton, int x, int y, int cols, int rows );

#include <interface/InterfaceDefs.h>
#include "win.h"
#include "tsb.h"

/*
typedef float  cvDimension;
typedef BView  cvBuffer;
typedef BPoint cvPoint;

struct cvRect {
	cvDimension left;
	cvDimension top;
	cvDimension right;
	cvDimension bottom;
};

typedef BPoint cvPoint;

struct cvPointList {
	cvPoint* points;
	int nPoints;
};
*/

struct cvColor {
	rgb_color color;

	uchar Red()   const { return color.red; }
	uchar Green() const { return color.green; }
	uchar Blue()  const { return color.blue; }

	// default ctor needed for arrays typecolors, litecolors
	cvColor()
	{
		color.red   = 0;
		color.green = 0;
		color.blue  = 0;
		color.alpha = 0;
	}

	cvColor( uchar r, uchar g, uchar b )
	{
		color.red   = r;
		color.green = g;
		color.blue  = b;
		color.alpha = 255;
	}

	cvColor( long i )
	{
		color.red   = (i >>12) & 0xff;
		color.green = (i >> 8) & 0xff;
		color.blue  = (i >> 4) & 0xff;
		color.alpha = (i     ) & 0xff;
	}

	cvColor( const rgb_color& c )
	{
		color.red   = c.red;
		color.green = c.green;
		color.blue  = c.blue;
		color.alpha = c.alpha;
	}

	cvColor( const cvColor& c )
	{
		color.red   = c.color.red;
		color.green = c.color.green;
		color.blue  = c.color.blue;
		color.alpha = c.color.alpha;
	}

	bool operator == ( const cvColor c ) const
	{
		return color.red==c.color.red && color.green == c.color.green && color.blue==c.color.blue && color.alpha==c.color.alpha;
	}

	cvColor& operator = ( const cvColor c )
	{
		if (this==&c)
			return *this;

		color.red   = c.color.red;
		color.green = c.color.green;
		color.blue  = c.color.blue;
		color.alpha = c.color.alpha;

		return *this;
	}

	operator rgb_color () { return color; }
};

const int MaxDefaultColors = 30;
extern cvColor defaultColors[ MaxDefaultColors ];

#endif	/* cvX_H */
