
/* $Header: /disk2g/john/dev/gfx/cview/RCS/example.cc,v 5.0 1997/01/23 19:54:41 elvis Exp elvis $ */

/* User demo program */

#include "iostream.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "cview.h"

#include <Application.h>
#include <Rect.h>
#include "win.h"

/*	General info about Cview graphics:

	The order of your program is important!  Here it is:
	1. declare needed variables and pointers to data and legend strings.
	2. allocate memory for data & strings, assign to appropriate pointers.
	3. call functions that assign data pointers to buttons:
		-first NEWBUTTON call will be the first button,
			second gives button #2, etc.
		-all OVERLAY calls are graphed on top of the most recent NEWBUTTON
			call.
	4. call cvDrawWindow to display the Cview graphics.
	5. do your calculation
		-at the end of each iteration, call cvUpdate() to graph new data.
		-in lengthy loops, call cvEventCheck() to respond to any pending
			mouse clicks.
	6. after calculation is done (but before data pointers are freed!) you
		can optionally call cvWait() to allow graphical access to the
		final state of the model.

	Coming attractions:
		Give user greater control over colors used.
		Faster drawing.
		Add a "NO_REDRAW" option to add only new features of graph
			at each iteration rather than redrawing entire graph.
		Add a multiple-graph option (ie, n graphs in one window).
		Internal allocation of legends and data arrays
			(so users can ignore allocation).
		And lots more.

	Enjoy!
*/

void DoGraphics( BApplication* app, TMainWindow* win );


main(int ac, char *av[])
{
	set_thread_priority( find_thread(NIL), B_DISPLAY_PRIORITY );
	BApplication* app = new BApplication('CvPr');

	BRect rect( 90, 90, 390, 390 );
	TMainWindow* win = new TMainWindow( rect, "Cview", B_TITLED_WINDOW, B_NOT_ZOOMABLE );

	DoGraphics( app, win );

	app->Run();
	delete app;

	return 0;
}
